package com.hjsoft.personnelTurnover.service;

package ..deTemp.1736849992368;

import com.hjsoft.apiservices.personnelTurnover.request.PtFlowParamQuery;
import com.hjsoft.apiservices.personnelTurnover.request.PtFlowRequest;
import com.hjsoft.apiservices.personnelTurnover.vo.PtFlowMonitorVO;
import com.hjsoft.base.basic.BasicPOJO;
import com.hjsoft.base.basic.RpcBasicService;
import com.hjsoft.base.staff.StaffEntity;
import com.hjsoft.base.staff.StaffService;
import com.hjsoft.base.staff.staffGroup.BdStaffGroupEntity;
import com.hjsoft.base.staff.staffGroup.BdStaffGroupMemberEntity;
import com.hjsoft.base.staff.staffGroup.BdStaffGroupMemberService;
import com.hjsoft.base.staff.staffGroup.BdStaffGroupService;
import com.hjsoft.base.structure.StructureEntity;
import com.hjsoft.base.structure.StructurePOJO;
import com.hjsoft.base.structure.StructureService;
import com.hjsoft.flowcenter.business.FcBusType;
import com.hjsoft.frame.parameter.ParameterUtils;
import com.hjsoft.frame.role.RoleEntity;
import com.hjsoft.frame.role.RoleService;
import com.hjsoft.frame.security.ShiroUser;
import com.hjsoft.frame.service.BaseServiceImplV2;
import com.hjsoft.frame.user.UserEntity;
import com.hjsoft.frame.userrole.UserRoleEntity;
import com.hjsoft.frame.userrole.UserRoleService;
import com.hjsoft.personnelTurnover.dao.PtFlowDAO;
import com.hjsoft.personnelTurnover.entity.PtFieldsEntity;
import com.hjsoft.personnelTurnover.entity.PtFlowEntity;
import com.hjsoft.personnelTurnover.entity.PtInstanceEntity;
import com.hjsoft.personnelTurnover.entity.PtListColumnsEntity;
import com.hjsoft.personnelTurnover.entity.PtNodeBranchConditionEntity;
import com.hjsoft.personnelTurnover.entity.PtNodeBranchEntity;
import com.hjsoft.personnelTurnover.entity.PtNodeEntity;
import com.hjsoft.personnelTurnover.entity.PtNodeMemberEntity;
import com.hjsoft.personnelTurnover.entity.PtSubEntity;
import com.hjsoft.personnelTurnover.listener.CamMember;
import com.hjsoft.personnelTurnover.service.PtFieldsService;
import com.hjsoft.personnelTurnover.service.PtFlowTriggerService;
import com.hjsoft.personnelTurnover.service.PtInstanceService;
import com.hjsoft.personnelTurnover.service.PtListColumnsService;
import com.hjsoft.personnelTurnover.service.PtNodeBranchConditionService;
import com.hjsoft.personnelTurnover.service.PtNodeBranchService;
import com.hjsoft.personnelTurnover.service.PtNodeMemberService;
import com.hjsoft.personnelTurnover.service.PtNodeService;
import com.hjsoft.personnelTurnover.service.PtSubService;
import com.mongodb.BasicDBObject;
import com.rap.common.dao.IBaseDAO;
import com.rap.common.entity.AutoIdEntity;
import com.rap.common.exception.EntityNotExistedException;
import com.rap.common.exception.ParamException;
import com.rap.common.exception.ServiceException;
import com.rap.common.exception.SystemException;
import com.rap.common.jpa.CustomRepository;
import com.rap.common.jpa.page.PageHolder;
import com.rap.common.utils.CollectionHelper;
import com.rap.common.utils.EntityUtil;
import com.rap.common.utils.Strings;
import java.io.File;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Set;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.compress.utils.Sets;
import org.apache.commons.lang3.StringUtils;
import org.apache.curator.shaded.com.google.common.collect.Lists;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.CriteriaDefinition;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.multipart.MultipartFile;

@Service
public class PtFlowService extends BaseServiceImplV2<PtFlowEntity, String> {
  Logger logger = LoggerFactory.getLogger(getClass());
  
  private final String formDocFixPath = "/ptf/form-docs/";
  
  @Autowired
  private PtFlowDAO dao;
  
  @Autowired
  private PtListColumnsService ptListColumnsService;
  
  @Autowired
  private PtSubService ptSubService;
  
  @Autowired
  private PtNodeService ptNodeService;
  
  @Autowired
  private RpcBasicService rpcBasicService;
  
  @Autowired
  private PtNodeMemberService ptNodeMemberService;
  
  @Autowired
  private PtInstanceService ptInstacneService;
  
  @Autowired
  private PtFlowTriggerService ptFlowTriggerService;
  
  @Autowired
  private MongoTemplate mongoTemplate;
  
  @Autowired
  private BdStaffGroupService staffGroupService;
  
  @Autowired
  private BdStaffGroupMemberService staffGroupMemberService;
  
  @Autowired
  private PtFieldsService ptFieldsService;
  
  @Autowired
  private StructureService structureService;
  
  @Autowired
  private UserRoleService userRoleService;
  
  @Autowired
  private StaffService staffService;
  
  @Autowired
  private RoleService roleService;
  
  @Autowired
  private PtNodeBranchService ptNodeBranchService;
  
  @Autowired
  private PtNodeBranchConditionService ptNodeBranchConditionService;
  
  protected CustomRepository<PtFlowEntity, String> getDAO() {
    return (CustomRepository<PtFlowEntity, String>)this.dao;
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public String saveOrUpdateFlow(PtFlowEntity flow, UserEntity user, List<String> triggerFlowIds) {
    String uuid = flow.getUuid();
    if (StringUtils.isBlank(uuid)) {
      StaffEntity staff = user.getStaff();
      flow.setUnitCode(staff.getUnitCode());
      flow.setUnitId(staff.getUnitId());
      flow = (PtFlowEntity)saveWithOperator((AutoIdEntity)flow);
      creatStartNode(flow.getUuid());
      uuid = flow.getUuid();
    } else {
      PtFlowEntity old = findPtFlowById(uuid, user.getTenantId());
      old.setDescription(flow.getDescription());
      old.setBusType(flow.getBusType());
      old.setBusSubType(flow.getBusSubType());
      old.setName(flow.getName());
      old.setIconColor(flow.getIconColor());
      old.setIconId(flow.getIconId());
      old.setIconUrl(flow.getIconUrl());
      old.setIconSource(flow.getIconSource());
      old.setEnableTriggerFlow(flow.getEnableTriggerFlow());
      old.setShareType(flow.getShareType());
      old.setArchType(flow.getArchType());
      old.setPersonBaseType(flow.getPersonBaseType());
      saveWithOperator((AutoIdEntity)old);
    } 
    this.ptFlowTriggerService.saveOrUpdate(uuid, triggerFlowIds, user.getTenantId());
    return uuid;
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public void creatStartNode(String flowId) {
    PtNodeEntity node = new PtNodeEntity();
    node.setFlowId(flowId);
    node.setParentId("0");
    node.setType(Integer.valueOf(0));
    node.setMemberType(0);
    node.setName("发起人");
    this.ptNodeService.saveWithOperator((AutoIdEntity)node);
    String nodeId = node.getUuid();
    PtNodeMemberEntity memberEntity = new PtNodeMemberEntity();
    memberEntity.setNodeId(nodeId);
    memberEntity.setFlowId(flowId);
    memberEntity.setName("发起人");
    memberEntity.setType(0);
    memberEntity.setMemberId("0");
    this.ptNodeMemberService.saveWithOperator((AutoIdEntity)memberEntity);
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public String copyFlow(PtFlowEntity flowEntity, String tenantId) {
    String flowId = flowEntity.getUuid();
    PtFlowEntity copyFlow = new PtFlowEntity();
    BeanUtils.copyProperties(flowEntity, copyFlow);
    copyFlow.setUuid(null);
    copyFlow.setShareType(flowEntity.getShareType());
    copyFlow.setName(copyFlow.getName() + copyFlow.getVersion() + "-副本");
    copyFlow.setVersion("1.0");
    copyFlow.setCopySourceId("0");
    copyFlow.setOrgCopySourceId("0");
    copyFlow.setLasted(Boolean.valueOf(true));
    copyFlow.setStatus(Integer.valueOf(1));
    saveWithOperator((AutoIdEntity)copyFlow);
    String newFlowId = copyFlow.getUuid();
    this.ptSubService.copySub(flowId, newFlowId, tenantId);
    this.ptListColumnsService.copyColumnsByFlowId(flowId, newFlowId, tenantId);
    this.ptNodeService.copyNode(flowId, newFlowId, tenantId);
    return copyFlow.getUuid();
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public String createNewVersion(PtFlowEntity flowEntity) {
    String flowId = flowEntity.getUuid();
    String tenantId = ShiroUser.getEntity().getTenantId();
    PtFlowEntity copyFlow = new PtFlowEntity();
    BeanUtils.copyProperties(flowEntity, copyFlow);
    copyFlow.setUuid(null);
    copyFlow.setStatus(Integer.valueOf(1));
    String version = flowEntity.getVersion();
    BigDecimal num = new BigDecimal(version);
    num = num.add(new BigDecimal("1"));
    version = num.toString();
    copyFlow.setShareType(flowEntity.getShareType());
    copyFlow.setVersion(version);
    copyFlow.setCopySourceId(flowEntity.getUuid());
    copyFlow.setOrgCopySourceId(("0".equals(flowEntity.getOrgCopySourceId()) || flowEntity.getOrgCopySourceId() == null) ? flowEntity.getUuid() : flowEntity.getOrgCopySourceId());
    saveWithOperator((AutoIdEntity)copyFlow);
    String newFlowId = copyFlow.getUuid();
    this.ptSubService.copySub(flowId, newFlowId, tenantId);
    this.ptListColumnsService.copyColumnsByFlowId(flowId, newFlowId, tenantId);
    this.ptNodeService.copyNode(flowId, newFlowId, tenantId);
    flowEntity.setLasted(Boolean.valueOf(false));
    saveWithOperator((AutoIdEntity)flowEntity);
    return copyFlow.getUuid();
  }
  
  public Integer stopFlow(PtFlowEntity flow) {
    Integer status = null;
    List<PtInstanceEntity> insts = this.ptInstacneService.findByFlowIds(Sets.newHashSet((Object[])new String[] { flow.getUuid() }));
    if (CollectionUtils.isNotEmpty(insts)) {
      flow.setStatus(Integer.valueOf(0));
      status = Integer.valueOf(0);
    } else {
      flow.setStatus(Integer.valueOf(1));
      status = Integer.valueOf(1);
    } 
    saveWithOperator((AutoIdEntity)flow);
    return status;
  }
  
  @Transactional
  public Map<String, Integer> stopFlows(List<PtFlowEntity> flows) {
    Map<String, Integer> flowId_status = new HashMap<>();
    if (CollectionUtils.isEmpty(flows))
      return flowId_status; 
    Set<String> flowIds = CollectionHelper.extractToSet(flows, o -> o.getUuid());
    List<PtInstanceEntity> instances = this.ptInstacneService.findByFlowIds(flowIds);
    Map<String, List<PtInstanceEntity>> flowId_insts = CollectionHelper.mapListDict(instances, o -> o.getFlowId());
    for (PtFlowEntity flow : flows) {
      List<PtInstanceEntity> insts = flowId_insts.get(flow.getUuid());
      if (CollectionUtils.isNotEmpty(insts)) {
        flow.setStatus(Integer.valueOf(0));
        flowId_status.put(flow.getUuid(), Integer.valueOf(0));
        continue;
      } 
      flow.setStatus(Integer.valueOf(1));
      flowId_status.put(flow.getUuid(), Integer.valueOf(1));
    } 
    saveWithOperator(flows);
    return flowId_status;
  }
  
  public String releaseFlow(PtFlowEntity flow) {
    flow.setStatus(Integer.valueOf(2));
    saveWithOperator((AutoIdEntity)flow);
    return flow.getUuid();
  }
  
  @Transactional
  public void releaseFlows(List<PtFlowEntity> flows, UserEntity user) {
    if (CollectionUtils.isEmpty(flows))
      return; 
    for (PtFlowEntity flow : flows) {
      checkPublishFlowError(flow.getUuid(), user);
      flow.setStatus(Integer.valueOf(2));
    } 
    saveWithOperator(flows);
  }
  
  public PtFlowEntity findPtFlowById(String flowId, String tenantId) {
    return this.dao.findByUuid(flowId, tenantId);
  }
  
  public Page<PtFlowEntity> queryWithOwnerFlow(PtFlowParamQuery query, UserEntity user, ShiroUser shiroUser) {
    List<Object> params = new ArrayList();
    params.add(user.getTenantId());
    StringBuilder sql = Strings.build(new String[] { "from PtFlowEntity a where a.tenantId=?1 " });
    if (StringUtils.isNotBlank(query.getBusType())) {
      params.add(query.getBusType());
      Strings.append(sql, new Object[] { "and a.busType=?", Integer.valueOf(params.size()), " " });
    } 
    if (StringUtils.isNotBlank(query.getBusSubType())) {
      params.add(query.getBusSubType());
      Strings.append(sql, new Object[] { "and a.busSubType=?", Integer.valueOf(params.size()), " " });
    } 
    if (StringUtils.isNotBlank(query.getName())) {
      params.add(Strings.join(new Object[] { "%", query.getName(), "%" }));
      Strings.append(sql, new Object[] { "and a.name like ?", Integer.valueOf(params.size()), " " });
    } 
    if (Objects.isNull(query.getStatus()) || (!Objects.isNull(query.getStatus()) && query.getStatus().intValue() == 2)) {
      List<StructurePOJO> manageRanges = shiroUser.getManageRanges();
      Set<String> orgIds = CollectionHelper.extractToSet(manageRanges, StructurePOJO::getOrgId);
      List<BasicPOJO> manageUnits = this.rpcBasicService.findManageByTenantId(orgIds, user.getTenantId());
      Set<String> unitIds = CollectionHelper.extractToSet(manageUnits, o -> o.getUuid());
      UserEntity userEntity = shiroUser.getUserEntity();
      StaffEntity staff = userEntity.getStaff();
      String unitId = (staff == null) ? null : staff.getUnitId();
      unitIds.add(unitId);
      if (CollectionUtils.isNotEmpty(unitIds)) {
        params.add(unitIds);
        Strings.append(sql, new Object[] { "and ((a.shareType=0 and a.unitId in (?", Integer.valueOf(params.size()), ") and a.status = 2) or (a.shareType=2 and a.status = 2) " });
      } else {
        Strings.append(sql, new String[] { "and ((a.shareType=2 and a.status = 2) " });
      } 
      List<BasicPOJO> pojo = this.rpcBasicService.findBasicByUuids(user.getTenantId(), orgIds);
      Set<String> orgParentIds = CollectionHelper.extractToSet(pojo, o -> o.getParentId());
      List<BasicPOJO> parentPojo = this.rpcBasicService.findBasicByUuids(user.getTenantId(), orgParentIds);
      Map<String, BasicPOJO> pId_pojo = CollectionHelper.mapDict(parentPojo, o -> o.getUuid());
      if (CollectionUtils.isNotEmpty(pojo)) {
        Strings.append(sql, new String[] { "or (a.shareType=1 and (" });
        int i = 0;
        for (BasicPOJO p : pojo) {
          if (pId_pojo != null && pId_pojo.size() > 0 && pId_pojo.containsKey(p.getParentId())) {
            params.add(Strings.join(new Object[] { ((BasicPOJO)pId_pojo.get(p.getParentId())).getCode(), "%" }));
          } else {
            params.add(Strings.join(new Object[] { p.getCode(), "%" }));
          } 
          if (i == 0) {
            Strings.append(sql, new Object[] { "a.unitCode like ?", Integer.valueOf(params.size()), " " });
          } else {
            Strings.append(sql, new Object[] { "or a.unitCode like ?", Integer.valueOf(params.size()), " " });
          } 
          if (i == pojo.size() - 1)
            Strings.append(sql, new String[] { ") and a.status = 2) " }); 
          i++;
        } 
      } 
      if (!Objects.isNull(query.getStatus())) {
        params.add(query.getStatus());
      } else {
        params.add(Lists.newArrayList((Object[])new Integer[] { Integer.valueOf(0), Integer.valueOf(1), Integer.valueOf(2) }));
      } 
      Strings.append(sql, new Object[] { "or (a.creator = '" + user.getUuid() + "' and a.status in (?", Integer.valueOf(params.size()), "))) " });
    } else {
      params.add(query.getStatus());
      Strings.append(sql, new Object[] { "and (a.creator = '" + user.getUuid() + "' and a.status in (?", Integer.valueOf(params.size()), ")) " });
    } 
    Strings.append(sql, new String[] { "and a.lasted=true" });
    Strings.append(sql, new String[] { " order by createTs desc" });
    return this.dao.findPage(sql.toString(), (Pageable)PageHolder.flush(), params.toArray());
  }
  
  public List<PtFlowRequest> queryAllWithOwnerFlow(UserEntity user, boolean isStaff, ShiroUser shiroUser) {
    List<Object> params = new ArrayList();
    params.add(user.getTenantId());
    Criteria criteria = new Criteria();
    criteria.and("tenantId").is(user.getTenantId());
    criteria.and("staffId").is(user.getStaff().getUuid());
    Query query = new Query();
    List<BasicDBObject> basicDBObjects = this.mongoTemplate.find(query.addCriteria((CriteriaDefinition)criteria), BasicDBObject.class, "A01");
    StringBuilder sql = Strings.build(new String[] { "select uuid,name,bus_sub_type,icon_source,icon_id,icon_color,description,version from pt_flow a where a.status=2 and a.tenant_id=?1 " });
    if (CollectionUtils.isNotEmpty(basicDBObjects) && isStaff) {
      String staffType = ((BasicDBObject)basicDBObjects.get(0)).getString("A0169");
      if (staffType != null && StringUtils.equals(staffType, "102")) {
        Strings.append(sql, new String[] { "and bus_sub_type in ('5','7','8','9') " });
      } else {
        Strings.append(sql, new String[] { "and bus_sub_type in ('5','8','9') " });
      } 
    } else if (CollectionUtils.isEmpty(basicDBObjects) && isStaff) {
      Strings.append(sql, new String[] { "and bus_sub_type in ('5','8','9') " });
    } 
    UserEntity userEntity = shiroUser.getUserEntity();
    StaffEntity staff = userEntity.getStaff();
    String unitId = (staff == null) ? null : staff.getUnitId();
    List<StructurePOJO> manageRanges = shiroUser.getManageRanges();
    Set<String> orgIds = CollectionHelper.extractToSet(manageRanges, StructurePOJO::getOrgId);
    List<BasicPOJO> manageUnits = this.rpcBasicService.findManageByTenantId(orgIds, user.getTenantId());
    Set<String> unitIds = CollectionHelper.extractToSet(manageUnits, o -> o.getUuid());
    unitIds.add(unitId);
    if (CollectionUtils.isNotEmpty(unitIds)) {
      params.add(unitIds);
      Strings.append(sql, new Object[] { "and ((a.share_type=0 and a.unit_id in (?", Integer.valueOf(params.size()), ")) " });
    } else {
      Strings.append(sql, new String[] { "and (" });
    } 
    if (CollectionUtils.isEmpty(orgIds))
      orgIds.add(unitId); 
    List<BasicPOJO> pojo = this.rpcBasicService.findBasicByUuids(user.getTenantId(), orgIds);
    Set<String> orgParentIds = CollectionHelper.extractToSet(pojo, o -> o.getParentId());
    List<BasicPOJO> parentPojo = this.rpcBasicService.findBasicByUuids(user.getTenantId(), orgParentIds);
    Map<String, BasicPOJO> pId_pojo = CollectionHelper.mapDict(parentPojo, o -> o.getUuid());
    if (CollectionUtils.isNotEmpty(pojo)) {
      Strings.append(sql, new String[] { "or (a.share_type=1 and (" });
      int i = 0;
      for (BasicPOJO p : pojo) {
        if (pId_pojo != null && pId_pojo.size() > 0 && pId_pojo.containsKey(p.getParentId())) {
          params.add(Strings.join(new Object[] { ((BasicPOJO)pId_pojo.get(p.getParentId())).getCode(), "%" }));
        } else {
          params.add(Strings.join(new Object[] { p.getCode(), "%" }));
        } 
        if (i == 0) {
          Strings.append(sql, new Object[] { "a.unit_code like ?", Integer.valueOf(params.size()), " " });
        } else {
          Strings.append(sql, new Object[] { "or a.unit_code like ?", Integer.valueOf(params.size()), " " });
        } 
        if (i == pojo.size() - 1)
          Strings.append(sql, new String[] { ")) " }); 
        i++;
      } 
    } else if (StringUtils.isNotBlank(staff.getUnitCode())) {
      params.add(Strings.join(new Object[] { staff.getUnitCode().substring(0, 3), "%" }));
      Strings.append(sql, new Object[] { "or (a.share_type=1 and (a.unit_code like ?", Integer.valueOf(params.size()), ")) " });
    } 
    if (CollectionUtils.isNotEmpty(unitIds)) {
      Strings.append(sql, new String[] { "or a.share_type=2 " });
    } else {
      Strings.append(sql, new String[] { " a.share_type=2 " });
    } 
    Strings.append(sql, new String[] { "or (a.share_type=-1 and a.creator = '" + user.getUuid() + "')) " });
    Strings.append(sql, new String[] { "and a.lasted=true" });
    Strings.append(sql, new String[] { " order by create_ts desc" });
    return this.dao.nativeQuery(sql.toString(), PtFlowRequest.class, params.toArray());
  }
  
  public String loadFlowMsgTemplates(String userMsgTemps, String userTaskTemps, PtFlowEntity flowEntity) {
    flowEntity.setUserMsgTemp(userMsgTemps);
    flowEntity.setUserTaskTemp(userTaskTemps);
    saveWithOperator((AutoIdEntity)flowEntity);
    return flowEntity.getUuid();
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public String deleteFlow(PtFlowEntity flowEntity, String flowId, String tenantId) throws ServiceException {
    String copySourceId = flowEntity.getCopySourceId();
    if (StringUtils.isNotBlank(copySourceId)) {
      PtFlowEntity flow = findPtFlowById(copySourceId, tenantId);
      if (flow != null) {
        flow.setLasted(Boolean.valueOf(true));
        saveWithOperator((AutoIdEntity)flow);
      } 
    } 
    delete((AutoIdEntity)flowEntity);
    this.ptSubService.deleteByFlow(flowId, tenantId);
    this.ptListColumnsService.deleteByFlow(flowId, tenantId);
    this.ptNodeService.deleteByFlow(flowId, tenantId);
    return flowId;
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public void deleteFlows(List<PtFlowEntity> flows, Set<String> flowIds, String tenantId) {
    Set<String> copySourceIds = Sets.newHashSet((Object[])new String[0]);
    for (PtFlowEntity flow : flows) {
      String copySourceId = flow.getCopySourceId();
      if (StringUtils.isNotBlank(copySourceId))
        copySourceIds.add(copySourceId); 
    } 
    List<PtFlowEntity> copyFlows = findPtFlowByIds(copySourceIds, tenantId);
    if (CollectionUtils.isNotEmpty(copyFlows))
      for (PtFlowEntity copyFlow : copyFlows)
        copyFlow.setLasted(Boolean.valueOf(true));  
    saveWithOperator(copyFlows);
    this.dao.delete(flows);
    this.ptSubService.deleteByFlowIds(flowIds, tenantId);
    this.ptListColumnsService.deleteByFlowIds(flowIds, tenantId);
    this.ptNodeService.deleteByFlowIds(flowIds, tenantId);
  }
  
  public List<PtFlowEntity> findAllHistoryFlowByCopyIds(PtFlowEntity flow, String tenantId) {
    List<PtFlowEntity> res = Lists.newArrayList();
    String orgCopySourceId = flow.getOrgCopySourceId();
    List<PtFlowEntity> orgCopyFlow = this.dao.findOrgCopyFlow(orgCopySourceId, tenantId);
    Map<String, PtFlowEntity> uuid_flow = CollectionHelper.mapDict(orgCopyFlow, o -> o.getUuid());
    if (CollectionUtils.isEmpty(orgCopyFlow))
      return res; 
    Map<String, FcBusType> map = CollectionHelper.mapDict(FcBusType.types(), t -> t.getCode());
    FcBusType fcBusUtil = map.get("A");
    Map<String, FcBusType> code_subBusType = CollectionHelper.mapDict(fcBusUtil.getSubTypes(), t -> t.getCode());
    String copyId = flow.getCopySourceId();
    while (!"0".equals(copyId)) {
      PtFlowEntity parentFlow = uuid_flow.get(copyId);
      if (parentFlow == null)
        return res; 
      if (fcBusUtil != null)
        parentFlow.setBusType(fcBusUtil.getName()); 
      if (!code_subBusType.isEmpty() && code_subBusType.get(parentFlow.getBusSubType()) != null)
        parentFlow.setBusSubType(((FcBusType)code_subBusType.get(parentFlow.getBusSubType())).getName()); 
      res.add(parentFlow);
      copyId = parentFlow.getCopySourceId();
    } 
    return res;
  }
  
  public void saveFormDocFile(MultipartFile uploadDocFile, PtFlowEntity flow) {
    String fn = uploadDocFile.getOriginalFilename();
    flow.setFormOrgin(fn);
    saveWithOperator((AutoIdEntity)flow);
    try {
      String formFileRoot = getFormDocRoot(flow.getTenantId());
      String formFilePath = Strings.join(new Object[] { formFileRoot, flow.getUuid() });
      File formFile = new File(formFilePath);
      if (formFile.exists()) {
        formFile.delete();
      } else {
        File dir = new File(formFileRoot);
        if (!dir.exists())
          dir.mkdirs(); 
      } 
      formFile.createNewFile();
      uploadDocFile.transferTo(formFile);
    } catch (Exception e) {
      throw new SystemException("Upload pt from file error: ", e);
    } 
  }
  
  public void delFormDocFile(PtFlowEntity flow) {
    flow.setFormOrgin("");
    saveWithOperator((AutoIdEntity)flow);
    try {
      File formFile = getFormDocFile(flow.getTenantId(), flow.getUuid());
      if (!formFile.exists())
        return; 
      formFile.delete();
    } catch (Exception e) {
      throw new SystemException(Strings.join(new Object[] { "Delete pt[", flow.getUuid(), "] from doc error: " }, ), e);
    } 
  }
  
  public File getFormDocFile(String tenantId, String flowId) {
    String formFileRoot = getFormDocRoot(tenantId);
    String formFilePath = Strings.join(new Object[] { formFileRoot, flowId });
    File formFile = new File(formFilePath);
    return formFile;
  }
  
  public String getFormDocRoot(String tenantId) {
    if (StringUtils.isBlank(tenantId))
      throw new RuntimeException("TenantId must not be null while "); 
    return Strings.join(new Object[] { getAttachPathRoot(), tenantId, "/ptf/form-docs/" });
  }
  
  private String getAttachPathRoot() {
    String root = ParameterUtils.getAttachmentPath();
    root = root.endsWith("/") ? root : (root + "/");
    return root;
  }
  
  public PtFlowEntity findPtFlowByIdAndPubish(String flowId, String tenantId) {
    return this.dao.findByUuidAndPublish(flowId, tenantId);
  }
  
  public List<PtFlowEntity> findSubFlowByUuid(List<PtFlowEntity> allHistoryFlowByCopyIds, String copySourceId) {
    Map<String, PtFlowEntity> uuid_Flow = CollectionHelper.mapDict(allHistoryFlowByCopyIds, o -> o.getUuid());
    List<PtFlowEntity> res = Lists.newArrayList();
    if (StringUtils.isBlank(copySourceId))
      return res; 
    while (StringUtils.isNotBlank(copySourceId) || "0".equals(copySourceId)) {
      PtFlowEntity flowEntity = uuid_Flow.get(copySourceId);
      if (flowEntity == null || res.contains(flowEntity))
        return res; 
      res.add(flowEntity);
      copySourceId = flowEntity.getCopySourceId();
    } 
    return res;
  }
  
  public Page<PtFlowMonitorVO> queryMonitorData(String busSubType, String name, UserEntity user, ShiroUser shiroUser) {
    List<Object> params = new ArrayList();
    params.add(user.getTenantId());
    StringBuilder sql = Strings.build(new String[] { "select * from pt_flow a where a.tenant_id=?1 and a.status = 2 " });
    if (StringUtils.isNotBlank(busSubType)) {
      params.add(busSubType);
      Strings.append(sql, new Object[] { "and a.bus_sub_type=?", Integer.valueOf(params.size()), " " });
    } 
    if (StringUtils.isNotBlank(name)) {
      params.add(Strings.join(new Object[] { "%", name, "%" }));
      Strings.append(sql, new Object[] { "and a.name like ?", Integer.valueOf(params.size()), " " });
    } 
    List<StructurePOJO> manageRanges = shiroUser.getManageRanges();
    Set<String> orgIds = CollectionHelper.extractToSet(manageRanges, StructurePOJO::getOrgId);
    List<BasicPOJO> manageUnits = this.rpcBasicService.findManageByTenantId(orgIds, user.getTenantId());
    Set<String> unitIds = CollectionHelper.extractToSet(manageUnits, o -> o.getUuid());
    if (CollectionUtils.isNotEmpty(unitIds)) {
      params.add(unitIds);
      Strings.append(sql, new Object[] { "and ((a.share_type=0 and a.unit_id in (?", Integer.valueOf(params.size()), ")) " });
    } else {
      Strings.append(sql, new String[] { "and (" });
    } 
    List<BasicPOJO> pojo = this.rpcBasicService.findBasicByUuids(user.getTenantId(), orgIds);
    Set<String> orgParentIds = CollectionHelper.extractToSet(pojo, o -> o.getParentId());
    List<BasicPOJO> parentPojo = this.rpcBasicService.findBasicByUuids(user.getTenantId(), orgParentIds);
    Map<String, BasicPOJO> pId_pojo = CollectionHelper.mapDict(parentPojo, o -> o.getUuid());
    if (CollectionUtils.isNotEmpty(pojo)) {
      Strings.append(sql, new String[] { "or (a.share_type=1 and (" });
      int i = 0;
      for (BasicPOJO p : pojo) {
        if (pId_pojo != null && pId_pojo.size() > 0 && pId_pojo.containsKey(p.getParentId())) {
          params.add(Strings.join(new Object[] { ((BasicPOJO)pId_pojo.get(p.getParentId())).getCode(), "%" }));
        } else {
          params.add(Strings.join(new Object[] { p.getCode(), "%" }));
        } 
        if (i == 0) {
          Strings.append(sql, new Object[] { "a.unit_code like ?", Integer.valueOf(params.size()), " " });
        } else {
          Strings.append(sql, new Object[] { "or a.unit_code like ?", Integer.valueOf(params.size()), " " });
        } 
        if (i == pojo.size() - 1)
          Strings.append(sql, new String[] { ")) " }); 
        i++;
      } 
    } 
    if (CollectionUtils.isNotEmpty(unitIds)) {
      Strings.append(sql, new String[] { "or a.share_type=2 " });
    } else {
      Strings.append(sql, new String[] { "a.share_type=2 " });
    } 
    Strings.append(sql, new String[] { "or (a.share_type=-1 and a.creator = '" + user.getUuid() + "')) " });
    Strings.append(sql, new String[] { " order by ", "create_ts desc" });
    Page<PtFlowMonitorVO> list = this.dao.nativeQueryPage(sql.toString(), PtFlowMonitorVO.class, (Pageable)PageHolder.flush(), params.toArray());
    if (CollectionUtils.isEmpty(list.getContent()))
      return list; 
    Set<String> flowIds = CollectionHelper.extractToSet(list.getContent(), o -> o.getUuid());
    List<PtInstanceEntity> insts = this.ptInstacneService.findByFlowIds(flowIds);
    Map<String, List<PtInstanceEntity>> flowId_inst = CollectionHelper.mapListDict(insts, o -> o.getFlowId());
    Map<String, FcBusType> map = CollectionHelper.mapDict(FcBusType.types(), t -> t.getCode());
    FcBusType fcBusUtil = map.get("A");
    Map<String, FcBusType> code_subBusType = CollectionHelper.mapDict(fcBusUtil.getSubTypes(), t -> t.getCode());
    for (PtFlowMonitorVO flowMonitor : list.getContent()) {
      List<PtInstanceEntity> instacneEntities = flowId_inst.get(flowMonitor.getUuid());
      flowMonitor.setBusSubType(((FcBusType)code_subBusType.get(flowMonitor.getBusSubType())).getName());
      Map<String, Long> statusCount = new HashMap<>();
      if (CollectionUtils.isEmpty(instacneEntities)) {
        statusCount.put("total", Long.valueOf(0L));
        statusCount.put(String.valueOf(2), Long.valueOf(0L));
        statusCount.put(String.valueOf(4), Long.valueOf(0L));
        statusCount.put(String.valueOf(3), Long.valueOf(0L));
        statusCount.put(String.valueOf(1), Long.valueOf(0L));
        statusCount.put(String.valueOf(6), Long.valueOf(0L));
        statusCount.put(String.valueOf(5), Long.valueOf(0L));
        statusCount.put(String.valueOf(8), Long.valueOf(0L));
        flowMonitor.setStatusCount(statusCount);
        continue;
      } 
      statusCount.put("total", Long.valueOf(instacneEntities.size()));
      statusCount.put(String.valueOf(2), Long.valueOf(instacneEntities.stream().filter(o -> (2 == o.getStatus().intValue())).count()));
      statusCount.put(String.valueOf(4), Long.valueOf(instacneEntities.stream().filter(o -> (4 == o.getStatus().intValue())).count()));
      statusCount.put(String.valueOf(3), Long.valueOf(instacneEntities.stream().filter(o -> (3 == o.getStatus().intValue())).count()));
      statusCount.put(String.valueOf(1), Long.valueOf(instacneEntities.stream().filter(o -> (1 == o.getStatus().intValue())).count()));
      statusCount.put(String.valueOf(6), Long.valueOf(instacneEntities.stream().filter(o -> (6 == o.getStatus().intValue())).count()));
      statusCount.put(String.valueOf(5), Long.valueOf(instacneEntities.stream().filter(o -> (5 == o.getStatus().intValue())).count()));
      statusCount.put(String.valueOf(8), Long.valueOf(instacneEntities.stream().filter(o -> (8 == o.getStatus().intValue())).count()));
      flowMonitor.setStatusCount(statusCount);
    } 
    return list;
  }
  
  public List<PtFlowEntity> findPtFlowByIds(Set<String> flowIds, String tenantId) {
    return this.dao.findByUuids(flowIds, tenantId);
  }
  
  public List<PtFlowEntity> findPtFlowByIds(List<String> flowIds, String tenantId) {
    return this.dao.findByUuids(flowIds, tenantId);
  }
  
  public List<PtFlowEntity> findNewVersionByFlowIds(Set<String> sourceIds, String tenantId) {
    return this.dao.findNewVersionByFlowIds(sourceIds, tenantId);
  }
  
  public boolean isIconUsed(String tenantId, String iconId) {
    String uid = (String)this.dao.nativeQueryOne("select uuid from pt_flow a where a.tenant_id=? and icon_id=?", String.class, new Object[] { tenantId, iconId });
    return StringUtils.isNotBlank(uid);
  }
  
  public void checkPublishFlowError(String flowId, UserEntity user) {
    String tenantId = user.getTenantId();
    StaffEntity staff = user.getStaff();
    checkSubAndFields(flowId, tenantId);
    checkBranch(flowId, tenantId);
    checkApprovePerson(flowId, staff, tenantId);
  }
  
  private void checkSubAndFields(String flowId, String tenantId) {
    List<PtSubEntity> subEntities = this.ptSubService.findByFlowId(flowId, tenantId);
    if (CollectionUtils.isEmpty(subEntities))
      throw new EntityNotExistedException("请设置流程模板子集以及指标信息！"); 
    List<PtFieldsEntity> fieldsEntityList = this.ptFieldsService.findByFlowId(flowId, tenantId);
    if (CollectionUtils.isEmpty(fieldsEntityList))
      throw new EntityNotExistedException("请设置流程模板指标信息！"); 
  }
  
  private void checkViewList(String flowId, String tenantId) {
    List<PtListColumnsEntity> columnsEntityList = this.ptListColumnsService.findColumnsByFlowId(flowId, tenantId);
    if (CollectionUtils.isEmpty(columnsEntityList))
      throw new EntityNotExistedException("请设置流程模板里面的视图列表！"); 
  }
  
  private void checkTaskMessage(PtFlowEntity flow) {
    if (StringUtils.isBlank(flow.getUserMsgTemp()) && StringUtils.isBlank(flow.getUserTaskTemp()))
      throw new ParamException("请设置流程模板待办和通知模板！"); 
  }
  
  private void checkBranch(String flowId, String tenantId) {
    try {
      PtNodeEntity nodes = this.ptNodeService.findTopByFlowId(flowId, tenantId);
      if (nodes == null)
        throw new EntityNotExistedException("流程没有配置发起人节点！"); 
      List<PtNodeBranchEntity> branchEntities = this.ptNodeBranchService.findByFlowId(flowId, tenantId);
      if (CollectionUtils.isEmpty(branchEntities)) {
        List<PtNodeBranchConditionEntity> branchConditionEntities = this.ptNodeBranchConditionService.findByFlowId(flowId, tenantId);
        if (CollectionUtils.isEmpty(branchConditionEntities) && branchEntities.size() > 1)
          throw new EntityNotExistedException("流程中条件分支只能有一个分支不设置条件！"); 
      } 
    } catch (Exception e) {
      throw new EntityNotExistedException("流程发起节点只能是一个节点！");
    } 
  }
  
  private void checkApprovePerson(String flowId, StaffEntity staff, String tenantId) {
    List<PtNodeEntity> nodes = this.ptNodeService.findByFlowId(flowId, tenantId);
    nodes = EntityUtil.copySimilar(nodes, PtNodeEntity.class);
    PtFlowEntity flow = findPtFlowById(flowId, tenantId);
    if (flow == null)
      throw new EntityNotExistedException("流程模板信息不存在！"); 
    checkTaskMessage(flow);
    Map<String, List<CamMember>> nodeId_roleAcms = new HashMap<>();
    extractMemerberStaffIdsAndRoleIds(flow, nodes, nodeId_roleAcms);
    if (!nodeId_roleAcms.isEmpty())
      extractJumpCheckStaffIdsFromRoleIds(nodeId_roleAcms, staff); 
  }
  
  private void extractMemerberStaffIdsAndRoleIds(PtFlowEntity flow, List<PtNodeEntity> branchNodes, Map<String, List<CamMember>> nodeId_roleAcms) {
    List<PtNodeMemberEntity> fcmembers = this.ptNodeMemberService.findByFlowId(flow.getUuid(), ShiroUser.getEntity().getTenantId());
    Map<String, List<PtNodeMemberEntity>> nodeId_fcmembers = CollectionHelper.mapListDict(fcmembers, m -> m.getNodeId());
    Integer shareType = flow.getShareType();
    for (PtNodeEntity node : branchNodes) {
      if (node == null || 
        node.typeOfBranch() || node.typeOfEnd())
        continue; 
      List<PtNodeMemberEntity> ms = nodeId_fcmembers.get(node.getUuid());
      if (ms == null || ms.isEmpty()) {
        this.logger.error("PtNode#{} does't has member !", node.getUuid());
        throw new EntityNotExistedException("存在未设置成员对象的流程节点!");
      } 
      if (node.memberOfGroup()) {
        for (PtNodeMemberEntity memberEntity : ms) {
          String memberId = memberEntity.getMemberId();
          List<BdStaffGroupMemberEntity> members = this.staffGroupMemberService.queryGroupMembers(memberId, memberEntity.getTenantId());
          if (CollectionUtils.isEmpty(members)) {
            BdStaffGroupEntity staffGroupEntity = this.staffGroupService.findByUuid(memberId);
            if (staffGroupEntity == null)
              throw new EntityNotExistedException("人员组不存在！"); 
            throw new ParamException(staffGroupEntity.getName() + "人员组没有关联人员，请联系管理员！");
          } 
        } 
        continue;
      } 
      if (node.memberOfRole()) {
        List<CamMember> nrs = CollectionHelper.extractToList(ms, m -> m.toCamMember(shareType.intValue()));
        nodeId_roleAcms.put(node.getUuid(), nrs);
        continue;
      } 
      if (node.memberOfPos())
        for (PtNodeMemberEntity memberEntity : ms) {
          String memberId = memberEntity.getMemberId();
          StructureEntity structureEntity = (StructureEntity)this.structureService.getById(memberId);
          List<StaffEntity> members = this.staffService.findByTenantIdAndPosId(ShiroUser.getEntity().getTenantId(), structureEntity.getOrgId());
          if (CollectionUtils.isEmpty(members))
            throw new ParamException(structureEntity.getName() + "岗位下无人员，请联系管理员！"); 
        }  
    } 
  }
  
  private void extractJumpCheckStaffIdsFromRoleIds(Map<String, List<CamMember>> nodeId_roleAcms, StaffEntity starterStaff) {
    String tenantId = starterStaff.getTenantId();
    String targetUnitId = starterStaff.getUnitId();
    String targetDeptId = starterStaff.getDeptId();
    if (StringUtils.isBlank(targetDeptId) && StringUtils.isBlank(targetUnitId))
      throw new ParamException("请设置当前账号员工所属单位或者部门！"); 
    boolean hasDeptId = StringUtils.isNotBlank(targetDeptId);
    StructureEntity starterDept = hasDeptId ? this.structureService.findByOrgId(tenantId, targetDeptId) : null;
    if (hasDeptId && starterDept == null)
      throw new ParamException("员工所属部门不存在！"); 
    StructureEntity targetUnit = this.structureService.findByOrgId(tenantId, targetUnitId);
    if (targetUnit == null)
      throw new ParamException("员工所属单位不存在！"); 
    List<CamMember> ams = CollectionHelper.extractMuiltyToList(nodeId_roleAcms.values(), ras -> ras);
    Map<String, CamMember> roleId_member = CollectionHelper.mapDict(ams, a -> a.getStaffId());
    Set<String> roleIds = roleId_member.keySet();
    List<UserRoleEntity> urs = this.userRoleService.findByRoleIds(tenantId, roleIds);
    CollectionHelper.removeAll(urs, ur -> ur.getRole().isStaff());
    checkRole(ams, roleId_member, roleIds, urs);
    Map<String, Set<String>> roleId_StaffIds = new HashMap<>();
    for (UserRoleEntity ur : urs) {
      RoleEntity role = ur.getRole();
      UserEntity user = ur.getUser();
      StaffEntity staff = user.getStaff();
      if (staff == null) {
        this.logger.error("==>User not binding staff ! role:{}-{}, user:{}-{}", new Object[] { role.getRoleName(), role.getUuid(), user.getUserName(), user.getUuid() });
        throw new EntityNotExistedException(Strings.join(new Object[] { "审批节点中角色 ", role.getRoleName(), " 下的账号  ", user.getUserName(), " 还未绑定人员信息，无法确定审批人！" }));
      } 
      String roleId = role.getUuid();
      Set<String> staffIds = roleId_StaffIds.computeIfAbsent(roleId, k -> new HashSet());
      staffIds.add(staff.getUuid());
    } 
    for (Map.Entry<String, List<CamMember>> e : nodeId_roleAcms.entrySet()) {
      for (CamMember role : e.getValue()) {
        Set<String> rsIds = roleId_StaffIds.get(role.getStaffId());
        if (rsIds == null)
          throw new ParamException(role.getName() + "角色未关联账号，请联系管理员！"); 
      } 
    } 
  }
  
  private void checkRole(List<CamMember> ams, Map<String, CamMember> roleId_member, Set<String> roleIds, List<UserRoleEntity> urs) {
    if (urs.isEmpty()) {
      List<RoleEntity> roles = this.roleService.findByUuids(roleIds);
      if (roles.isEmpty()) {
        Set<String> set = CollectionHelper.extractToSet(ams, am -> am.getName());
        throw new EntityNotExistedException("流程中所选角色：" + String.join("、", set) + " 已删除！");
      } 
      Set<String> noUserRoles = CollectionHelper.extractToSet(roles, r -> r.getRoleName());
      if (roleIds.size() == roles.size())
        throw new EntityNotExistedException("流程中所选角色：" + String.join("、", noUserRoles) + " 还未关联人员！"); 
      for (RoleEntity r : roles)
        roleId_member.remove(r.getUuid()); 
      Set<String> deleteRoles = CollectionHelper.extractToSet(roleId_member.values(), am -> am.getName());
      throw new EntityNotExistedException("流程中所选角色：" + String.join("、", deleteRoles) + " 已删除！所选角色：" + String.join("、", noUserRoles) + " 还未关联人员!");
    } 
  }
  
  public List<PtFlowEntity> findByMsgTempId(String templateId, String tenantId) {
    return this.dao.findByMsgTempId(templateId, tenantId);
  }
}
